<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/*<a name="line.1"></a>
<span class="sourceLineNo">002</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.2"></a>
<span class="sourceLineNo">003</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.3"></a>
<span class="sourceLineNo">004</span> * this work for additional information regarding copyright ownership.<a name="line.4"></a>
<span class="sourceLineNo">005</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.5"></a>
<span class="sourceLineNo">006</span> * (the "License"); you may not use this file except in compliance with<a name="line.6"></a>
<span class="sourceLineNo">007</span> * the License.  You may obtain a copy of the License at<a name="line.7"></a>
<span class="sourceLineNo">008</span> *<a name="line.8"></a>
<span class="sourceLineNo">009</span> *      http://www.apache.org/licenses/LICENSE-2.0<a name="line.9"></a>
<span class="sourceLineNo">010</span> *<a name="line.10"></a>
<span class="sourceLineNo">011</span> * Unless required by applicable law or agreed to in writing, software<a name="line.11"></a>
<span class="sourceLineNo">012</span> * distributed under the License is distributed on an "AS IS" BASIS,<a name="line.12"></a>
<span class="sourceLineNo">013</span> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.13"></a>
<span class="sourceLineNo">014</span> * See the License for the specific language governing permissions and<a name="line.14"></a>
<span class="sourceLineNo">015</span> * limitations under the License.<a name="line.15"></a>
<span class="sourceLineNo">016</span> */<a name="line.16"></a>
<span class="sourceLineNo">017</span><a name="line.17"></a>
<span class="sourceLineNo">018</span>package org.apache.commons.dbcp2;<a name="line.18"></a>
<span class="sourceLineNo">019</span><a name="line.19"></a>
<span class="sourceLineNo">020</span>import java.sql.CallableStatement;<a name="line.20"></a>
<span class="sourceLineNo">021</span>import java.sql.Connection;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import java.sql.PreparedStatement;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import java.sql.SQLException;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import java.util.NoSuchElementException;<a name="line.24"></a>
<span class="sourceLineNo">025</span><a name="line.25"></a>
<span class="sourceLineNo">026</span>import org.apache.commons.pool2.KeyedObjectPool;<a name="line.26"></a>
<span class="sourceLineNo">027</span>import org.apache.commons.pool2.KeyedPooledObjectFactory;<a name="line.27"></a>
<span class="sourceLineNo">028</span>import org.apache.commons.pool2.PooledObject;<a name="line.28"></a>
<span class="sourceLineNo">029</span>import org.apache.commons.pool2.impl.DefaultPooledObject;<a name="line.29"></a>
<span class="sourceLineNo">030</span><a name="line.30"></a>
<span class="sourceLineNo">031</span>/**<a name="line.31"></a>
<span class="sourceLineNo">032</span> * A {@link DelegatingConnection} that pools {@link PreparedStatement}s.<a name="line.32"></a>
<span class="sourceLineNo">033</span> * &lt;p&gt;<a name="line.33"></a>
<span class="sourceLineNo">034</span> * The {@link #prepareStatement} and {@link #prepareCall} methods, rather than creating a new PreparedStatement each<a name="line.34"></a>
<span class="sourceLineNo">035</span> * time, may actually pull the statement from a pool of unused statements. The {@link PreparedStatement#close} method of<a name="line.35"></a>
<span class="sourceLineNo">036</span> * the returned statement doesn't actually close the statement, but rather returns it to the pool. (See<a name="line.36"></a>
<span class="sourceLineNo">037</span> * {@link PoolablePreparedStatement}, {@link PoolableCallableStatement}.)<a name="line.37"></a>
<span class="sourceLineNo">038</span> * &lt;/p&gt;<a name="line.38"></a>
<span class="sourceLineNo">039</span> *<a name="line.39"></a>
<span class="sourceLineNo">040</span> * @see PoolablePreparedStatement<a name="line.40"></a>
<span class="sourceLineNo">041</span> * @since 2.0<a name="line.41"></a>
<span class="sourceLineNo">042</span> */<a name="line.42"></a>
<span class="sourceLineNo">043</span>public class PoolingConnection extends DelegatingConnection&lt;Connection&gt;<a name="line.43"></a>
<span class="sourceLineNo">044</span>        implements KeyedPooledObjectFactory&lt;PStmtKey, DelegatingPreparedStatement&gt; {<a name="line.44"></a>
<span class="sourceLineNo">045</span><a name="line.45"></a>
<span class="sourceLineNo">046</span>    /**<a name="line.46"></a>
<span class="sourceLineNo">047</span>     * Statement types.<a name="line.47"></a>
<span class="sourceLineNo">048</span>     *<a name="line.48"></a>
<span class="sourceLineNo">049</span>     * @since 2.0 protected enum.<a name="line.49"></a>
<span class="sourceLineNo">050</span>     * @since 2.4.0 public enum.<a name="line.50"></a>
<span class="sourceLineNo">051</span>     */<a name="line.51"></a>
<span class="sourceLineNo">052</span>    public enum StatementType {<a name="line.52"></a>
<span class="sourceLineNo">053</span><a name="line.53"></a>
<span class="sourceLineNo">054</span>        /**<a name="line.54"></a>
<span class="sourceLineNo">055</span>         * Callable statement.<a name="line.55"></a>
<span class="sourceLineNo">056</span>         */<a name="line.56"></a>
<span class="sourceLineNo">057</span>        CALLABLE_STATEMENT,<a name="line.57"></a>
<span class="sourceLineNo">058</span><a name="line.58"></a>
<span class="sourceLineNo">059</span>        /**<a name="line.59"></a>
<span class="sourceLineNo">060</span>         * Prepared statement.<a name="line.60"></a>
<span class="sourceLineNo">061</span>         */<a name="line.61"></a>
<span class="sourceLineNo">062</span>        PREPARED_STATEMENT<a name="line.62"></a>
<span class="sourceLineNo">063</span>    }<a name="line.63"></a>
<span class="sourceLineNo">064</span><a name="line.64"></a>
<span class="sourceLineNo">065</span>    /** Pool of {@link PreparedStatement}s. and {@link CallableStatement}s */<a name="line.65"></a>
<span class="sourceLineNo">066</span>    private KeyedObjectPool&lt;PStmtKey, DelegatingPreparedStatement&gt; pstmtPool;<a name="line.66"></a>
<span class="sourceLineNo">067</span><a name="line.67"></a>
<span class="sourceLineNo">068</span>    private boolean clearStatementPoolOnReturn = false;<a name="line.68"></a>
<span class="sourceLineNo">069</span><a name="line.69"></a>
<span class="sourceLineNo">070</span>    /**<a name="line.70"></a>
<span class="sourceLineNo">071</span>     * Constructor.<a name="line.71"></a>
<span class="sourceLineNo">072</span>     *<a name="line.72"></a>
<span class="sourceLineNo">073</span>     * @param connection<a name="line.73"></a>
<span class="sourceLineNo">074</span>     *            the underlying {@link Connection}.<a name="line.74"></a>
<span class="sourceLineNo">075</span>     */<a name="line.75"></a>
<span class="sourceLineNo">076</span>    public PoolingConnection(final Connection connection) {<a name="line.76"></a>
<span class="sourceLineNo">077</span>        super(connection);<a name="line.77"></a>
<span class="sourceLineNo">078</span>    }<a name="line.78"></a>
<span class="sourceLineNo">079</span><a name="line.79"></a>
<span class="sourceLineNo">080</span>    /**<a name="line.80"></a>
<span class="sourceLineNo">081</span>     * {@link KeyedPooledObjectFactory} method for activating pooled statements.<a name="line.81"></a>
<span class="sourceLineNo">082</span>     *<a name="line.82"></a>
<span class="sourceLineNo">083</span>     * @param key<a name="line.83"></a>
<span class="sourceLineNo">084</span>     *            ignored<a name="line.84"></a>
<span class="sourceLineNo">085</span>     * @param pooledObject<a name="line.85"></a>
<span class="sourceLineNo">086</span>     *            wrapped pooled statement to be activated<a name="line.86"></a>
<span class="sourceLineNo">087</span>     */<a name="line.87"></a>
<span class="sourceLineNo">088</span>    @Override<a name="line.88"></a>
<span class="sourceLineNo">089</span>    public void activateObject(final PStmtKey key, final PooledObject&lt;DelegatingPreparedStatement&gt; pooledObject)<a name="line.89"></a>
<span class="sourceLineNo">090</span>            throws Exception {<a name="line.90"></a>
<span class="sourceLineNo">091</span>        pooledObject.getObject().activate();<a name="line.91"></a>
<span class="sourceLineNo">092</span>    }<a name="line.92"></a>
<span class="sourceLineNo">093</span><a name="line.93"></a>
<span class="sourceLineNo">094</span>    /**<a name="line.94"></a>
<span class="sourceLineNo">095</span>     * Closes and frees all {@link PreparedStatement}s or {@link CallableStatement}s from the pool, and close the<a name="line.95"></a>
<span class="sourceLineNo">096</span>     * underlying connection.<a name="line.96"></a>
<span class="sourceLineNo">097</span>     */<a name="line.97"></a>
<span class="sourceLineNo">098</span>    @Override<a name="line.98"></a>
<span class="sourceLineNo">099</span>    public synchronized void close() throws SQLException {<a name="line.99"></a>
<span class="sourceLineNo">100</span>        try {<a name="line.100"></a>
<span class="sourceLineNo">101</span>            if (null != pstmtPool) {<a name="line.101"></a>
<span class="sourceLineNo">102</span>                final KeyedObjectPool&lt;PStmtKey, DelegatingPreparedStatement&gt; oldpool = pstmtPool;<a name="line.102"></a>
<span class="sourceLineNo">103</span>                pstmtPool = null;<a name="line.103"></a>
<span class="sourceLineNo">104</span>                try {<a name="line.104"></a>
<span class="sourceLineNo">105</span>                    oldpool.close();<a name="line.105"></a>
<span class="sourceLineNo">106</span>                } catch (final RuntimeException e) {<a name="line.106"></a>
<span class="sourceLineNo">107</span>                    throw e;<a name="line.107"></a>
<span class="sourceLineNo">108</span>                } catch (final Exception e) {<a name="line.108"></a>
<span class="sourceLineNo">109</span>                    throw new SQLException("Cannot close connection", e);<a name="line.109"></a>
<span class="sourceLineNo">110</span>                }<a name="line.110"></a>
<span class="sourceLineNo">111</span>            }<a name="line.111"></a>
<span class="sourceLineNo">112</span>        } finally {<a name="line.112"></a>
<span class="sourceLineNo">113</span>            try {<a name="line.113"></a>
<span class="sourceLineNo">114</span>                getDelegateInternal().close();<a name="line.114"></a>
<span class="sourceLineNo">115</span>            } finally {<a name="line.115"></a>
<span class="sourceLineNo">116</span>                setClosedInternal(true);<a name="line.116"></a>
<span class="sourceLineNo">117</span>            }<a name="line.117"></a>
<span class="sourceLineNo">118</span>        }<a name="line.118"></a>
<span class="sourceLineNo">119</span>    }<a name="line.119"></a>
<span class="sourceLineNo">120</span><a name="line.120"></a>
<span class="sourceLineNo">121</span>    /**<a name="line.121"></a>
<span class="sourceLineNo">122</span>     * Notification from {@link PoolableConnection} that we returned to the pool.<a name="line.122"></a>
<span class="sourceLineNo">123</span>     *<a name="line.123"></a>
<span class="sourceLineNo">124</span>     * @throws SQLException when &lt;code&gt;clearStatementPoolOnReturn&lt;/code&gt; is true and the statement pool could not be<a name="line.124"></a>
<span class="sourceLineNo">125</span>     *                      cleared<a name="line.125"></a>
<span class="sourceLineNo">126</span>     * @since 2.8.0<a name="line.126"></a>
<span class="sourceLineNo">127</span>     */<a name="line.127"></a>
<span class="sourceLineNo">128</span>    public void connectionReturnedToPool() throws SQLException {<a name="line.128"></a>
<span class="sourceLineNo">129</span>        if (pstmtPool != null &amp;&amp; clearStatementPoolOnReturn) {<a name="line.129"></a>
<span class="sourceLineNo">130</span>            try {<a name="line.130"></a>
<span class="sourceLineNo">131</span>                pstmtPool.clear();<a name="line.131"></a>
<span class="sourceLineNo">132</span>            } catch (Exception e) {<a name="line.132"></a>
<span class="sourceLineNo">133</span>                throw new SQLException("Error clearing statement pool", e);<a name="line.133"></a>
<span class="sourceLineNo">134</span>            }<a name="line.134"></a>
<span class="sourceLineNo">135</span>        }<a name="line.135"></a>
<span class="sourceLineNo">136</span>    }<a name="line.136"></a>
<span class="sourceLineNo">137</span><a name="line.137"></a>
<span class="sourceLineNo">138</span>    /**<a name="line.138"></a>
<span class="sourceLineNo">139</span>     * Creates a PStmtKey for the given arguments.<a name="line.139"></a>
<span class="sourceLineNo">140</span>     *<a name="line.140"></a>
<span class="sourceLineNo">141</span>     * @param sql<a name="line.141"></a>
<span class="sourceLineNo">142</span>     *            the SQL string used to define the statement<a name="line.142"></a>
<span class="sourceLineNo">143</span>     *<a name="line.143"></a>
<span class="sourceLineNo">144</span>     * @return the PStmtKey created for the given arguments.<a name="line.144"></a>
<span class="sourceLineNo">145</span>     */<a name="line.145"></a>
<span class="sourceLineNo">146</span>    protected PStmtKey createKey(final String sql) {<a name="line.146"></a>
<span class="sourceLineNo">147</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull());<a name="line.147"></a>
<span class="sourceLineNo">148</span>    }<a name="line.148"></a>
<span class="sourceLineNo">149</span><a name="line.149"></a>
<span class="sourceLineNo">150</span>    /**<a name="line.150"></a>
<span class="sourceLineNo">151</span>     * Creates a PStmtKey for the given arguments.<a name="line.151"></a>
<span class="sourceLineNo">152</span>     *<a name="line.152"></a>
<span class="sourceLineNo">153</span>     * @param sql<a name="line.153"></a>
<span class="sourceLineNo">154</span>     *            the SQL string used to define the statement<a name="line.154"></a>
<span class="sourceLineNo">155</span>     * @param columnIndexes<a name="line.155"></a>
<span class="sourceLineNo">156</span>     *            An array of column indexes indicating the columns that should be returned from the inserted row or<a name="line.156"></a>
<span class="sourceLineNo">157</span>     *            rows.<a name="line.157"></a>
<span class="sourceLineNo">158</span>     *<a name="line.158"></a>
<span class="sourceLineNo">159</span>     * @return the PStmtKey created for the given arguments.<a name="line.159"></a>
<span class="sourceLineNo">160</span>     */<a name="line.160"></a>
<span class="sourceLineNo">161</span>    protected PStmtKey createKey(final String sql, final int columnIndexes[]) {<a name="line.161"></a>
<span class="sourceLineNo">162</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), columnIndexes);<a name="line.162"></a>
<span class="sourceLineNo">163</span>    }<a name="line.163"></a>
<span class="sourceLineNo">164</span><a name="line.164"></a>
<span class="sourceLineNo">165</span>    /**<a name="line.165"></a>
<span class="sourceLineNo">166</span>     * Creates a PStmtKey for the given arguments.<a name="line.166"></a>
<span class="sourceLineNo">167</span>     *<a name="line.167"></a>
<span class="sourceLineNo">168</span>     * @param sql<a name="line.168"></a>
<span class="sourceLineNo">169</span>     *            the SQL string used to define the statement<a name="line.169"></a>
<span class="sourceLineNo">170</span>     * @param autoGeneratedKeys<a name="line.170"></a>
<span class="sourceLineNo">171</span>     *            A flag indicating whether auto-generated keys should be returned; one of<a name="line.171"></a>
<span class="sourceLineNo">172</span>     *            &lt;code&gt;Statement.RETURN_GENERATED_KEYS&lt;/code&gt; or &lt;code&gt;Statement.NO_GENERATED_KEYS&lt;/code&gt;.<a name="line.172"></a>
<span class="sourceLineNo">173</span>     *<a name="line.173"></a>
<span class="sourceLineNo">174</span>     * @return the PStmtKey created for the given arguments.<a name="line.174"></a>
<span class="sourceLineNo">175</span>     */<a name="line.175"></a>
<span class="sourceLineNo">176</span>    protected PStmtKey createKey(final String sql, final int autoGeneratedKeys) {<a name="line.176"></a>
<span class="sourceLineNo">177</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), autoGeneratedKeys);<a name="line.177"></a>
<span class="sourceLineNo">178</span>    }<a name="line.178"></a>
<span class="sourceLineNo">179</span><a name="line.179"></a>
<span class="sourceLineNo">180</span>    /**<a name="line.180"></a>
<span class="sourceLineNo">181</span>     * Creates a PStmtKey for the given arguments.<a name="line.181"></a>
<span class="sourceLineNo">182</span>     *<a name="line.182"></a>
<span class="sourceLineNo">183</span>     * @param sql<a name="line.183"></a>
<span class="sourceLineNo">184</span>     *            the SQL string used to define the statement<a name="line.184"></a>
<span class="sourceLineNo">185</span>     * @param resultSetType<a name="line.185"></a>
<span class="sourceLineNo">186</span>     *            result set type<a name="line.186"></a>
<span class="sourceLineNo">187</span>     * @param resultSetConcurrency<a name="line.187"></a>
<span class="sourceLineNo">188</span>     *            result set concurrency<a name="line.188"></a>
<span class="sourceLineNo">189</span>     *<a name="line.189"></a>
<span class="sourceLineNo">190</span>     * @return the PStmtKey created for the given arguments.<a name="line.190"></a>
<span class="sourceLineNo">191</span>     */<a name="line.191"></a>
<span class="sourceLineNo">192</span>    protected PStmtKey createKey(final String sql, final int resultSetType, final int resultSetConcurrency) {<a name="line.192"></a>
<span class="sourceLineNo">193</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), resultSetType, resultSetConcurrency);<a name="line.193"></a>
<span class="sourceLineNo">194</span>    }<a name="line.194"></a>
<span class="sourceLineNo">195</span><a name="line.195"></a>
<span class="sourceLineNo">196</span>    /**<a name="line.196"></a>
<span class="sourceLineNo">197</span>     * Creates a PStmtKey for the given arguments.<a name="line.197"></a>
<span class="sourceLineNo">198</span>     *<a name="line.198"></a>
<span class="sourceLineNo">199</span>     * @param sql<a name="line.199"></a>
<span class="sourceLineNo">200</span>     *            the SQL string used to define the statement<a name="line.200"></a>
<span class="sourceLineNo">201</span>     * @param resultSetType<a name="line.201"></a>
<span class="sourceLineNo">202</span>     *            result set type<a name="line.202"></a>
<span class="sourceLineNo">203</span>     * @param resultSetConcurrency<a name="line.203"></a>
<span class="sourceLineNo">204</span>     *            result set concurrency<a name="line.204"></a>
<span class="sourceLineNo">205</span>     * @param resultSetHoldability<a name="line.205"></a>
<span class="sourceLineNo">206</span>     *            result set holdability<a name="line.206"></a>
<span class="sourceLineNo">207</span>     *<a name="line.207"></a>
<span class="sourceLineNo">208</span>     * @return the PStmtKey created for the given arguments.<a name="line.208"></a>
<span class="sourceLineNo">209</span>     */<a name="line.209"></a>
<span class="sourceLineNo">210</span>    protected PStmtKey createKey(final String sql, final int resultSetType, final int resultSetConcurrency,<a name="line.210"></a>
<span class="sourceLineNo">211</span>            final int resultSetHoldability) {<a name="line.211"></a>
<span class="sourceLineNo">212</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), resultSetType, resultSetConcurrency,<a name="line.212"></a>
<span class="sourceLineNo">213</span>                resultSetHoldability);<a name="line.213"></a>
<span class="sourceLineNo">214</span>    }<a name="line.214"></a>
<span class="sourceLineNo">215</span><a name="line.215"></a>
<span class="sourceLineNo">216</span>    /**<a name="line.216"></a>
<span class="sourceLineNo">217</span>     * Creates a PStmtKey for the given arguments.<a name="line.217"></a>
<span class="sourceLineNo">218</span>     *<a name="line.218"></a>
<span class="sourceLineNo">219</span>     * @param sql<a name="line.219"></a>
<span class="sourceLineNo">220</span>     *            the SQL string used to define the statement<a name="line.220"></a>
<span class="sourceLineNo">221</span>     * @param resultSetType<a name="line.221"></a>
<span class="sourceLineNo">222</span>     *            result set type<a name="line.222"></a>
<span class="sourceLineNo">223</span>     * @param resultSetConcurrency<a name="line.223"></a>
<span class="sourceLineNo">224</span>     *            result set concurrency<a name="line.224"></a>
<span class="sourceLineNo">225</span>     * @param resultSetHoldability<a name="line.225"></a>
<span class="sourceLineNo">226</span>     *            result set holdability<a name="line.226"></a>
<span class="sourceLineNo">227</span>     * @param statementType<a name="line.227"></a>
<span class="sourceLineNo">228</span>     *            statement type<a name="line.228"></a>
<span class="sourceLineNo">229</span>     *<a name="line.229"></a>
<span class="sourceLineNo">230</span>     * @return the PStmtKey created for the given arguments.<a name="line.230"></a>
<span class="sourceLineNo">231</span>     */<a name="line.231"></a>
<span class="sourceLineNo">232</span>    protected PStmtKey createKey(final String sql, final int resultSetType, final int resultSetConcurrency,<a name="line.232"></a>
<span class="sourceLineNo">233</span>            final int resultSetHoldability, final StatementType statementType) {<a name="line.233"></a>
<span class="sourceLineNo">234</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), resultSetType, resultSetConcurrency,<a name="line.234"></a>
<span class="sourceLineNo">235</span>                resultSetHoldability, statementType);<a name="line.235"></a>
<span class="sourceLineNo">236</span>    }<a name="line.236"></a>
<span class="sourceLineNo">237</span><a name="line.237"></a>
<span class="sourceLineNo">238</span>    /**<a name="line.238"></a>
<span class="sourceLineNo">239</span>     * Creates a PStmtKey for the given arguments.<a name="line.239"></a>
<span class="sourceLineNo">240</span>     *<a name="line.240"></a>
<span class="sourceLineNo">241</span>     * @param sql<a name="line.241"></a>
<span class="sourceLineNo">242</span>     *            the SQL string used to define the statement<a name="line.242"></a>
<span class="sourceLineNo">243</span>     * @param resultSetType<a name="line.243"></a>
<span class="sourceLineNo">244</span>     *            result set type<a name="line.244"></a>
<span class="sourceLineNo">245</span>     * @param resultSetConcurrency<a name="line.245"></a>
<span class="sourceLineNo">246</span>     *            result set concurrency<a name="line.246"></a>
<span class="sourceLineNo">247</span>     * @param statementType<a name="line.247"></a>
<span class="sourceLineNo">248</span>     *            statement type<a name="line.248"></a>
<span class="sourceLineNo">249</span>     *<a name="line.249"></a>
<span class="sourceLineNo">250</span>     * @return the PStmtKey created for the given arguments.<a name="line.250"></a>
<span class="sourceLineNo">251</span>     */<a name="line.251"></a>
<span class="sourceLineNo">252</span>    protected PStmtKey createKey(final String sql, final int resultSetType, final int resultSetConcurrency,<a name="line.252"></a>
<span class="sourceLineNo">253</span>            final StatementType statementType) {<a name="line.253"></a>
<span class="sourceLineNo">254</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), resultSetType, resultSetConcurrency, statementType);<a name="line.254"></a>
<span class="sourceLineNo">255</span>    }<a name="line.255"></a>
<span class="sourceLineNo">256</span><a name="line.256"></a>
<span class="sourceLineNo">257</span>    /**<a name="line.257"></a>
<span class="sourceLineNo">258</span>     * Creates a PStmtKey for the given arguments.<a name="line.258"></a>
<span class="sourceLineNo">259</span>     *<a name="line.259"></a>
<span class="sourceLineNo">260</span>     * @param sql<a name="line.260"></a>
<span class="sourceLineNo">261</span>     *            the SQL string used to define the statement<a name="line.261"></a>
<span class="sourceLineNo">262</span>     * @param statementType<a name="line.262"></a>
<span class="sourceLineNo">263</span>     *            statement type<a name="line.263"></a>
<span class="sourceLineNo">264</span>     *<a name="line.264"></a>
<span class="sourceLineNo">265</span>     * @return the PStmtKey created for the given arguments.<a name="line.265"></a>
<span class="sourceLineNo">266</span>     */<a name="line.266"></a>
<span class="sourceLineNo">267</span>    protected PStmtKey createKey(final String sql, final StatementType statementType) {<a name="line.267"></a>
<span class="sourceLineNo">268</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), statementType, null);<a name="line.268"></a>
<span class="sourceLineNo">269</span>    }<a name="line.269"></a>
<span class="sourceLineNo">270</span><a name="line.270"></a>
<span class="sourceLineNo">271</span>    /**<a name="line.271"></a>
<span class="sourceLineNo">272</span>     * Creates a PStmtKey for the given arguments.<a name="line.272"></a>
<span class="sourceLineNo">273</span>     *<a name="line.273"></a>
<span class="sourceLineNo">274</span>     * @param sql<a name="line.274"></a>
<span class="sourceLineNo">275</span>     *            the SQL string used to define the statement<a name="line.275"></a>
<span class="sourceLineNo">276</span>     * @param columnNames<a name="line.276"></a>
<span class="sourceLineNo">277</span>     *            column names<a name="line.277"></a>
<span class="sourceLineNo">278</span>     *<a name="line.278"></a>
<span class="sourceLineNo">279</span>     * @return the PStmtKey created for the given arguments.<a name="line.279"></a>
<span class="sourceLineNo">280</span>     */<a name="line.280"></a>
<span class="sourceLineNo">281</span>    protected PStmtKey createKey(final String sql, final String columnNames[]) {<a name="line.281"></a>
<span class="sourceLineNo">282</span>        return new PStmtKey(normalizeSQL(sql), getCatalogOrNull(), getSchemaOrNull(), columnNames);<a name="line.282"></a>
<span class="sourceLineNo">283</span>    }<a name="line.283"></a>
<span class="sourceLineNo">284</span><a name="line.284"></a>
<span class="sourceLineNo">285</span>    /**<a name="line.285"></a>
<span class="sourceLineNo">286</span>     * {@link KeyedPooledObjectFactory} method for destroying PoolablePreparedStatements and PoolableCallableStatements.<a name="line.286"></a>
<span class="sourceLineNo">287</span>     * Closes the underlying statement.<a name="line.287"></a>
<span class="sourceLineNo">288</span>     *<a name="line.288"></a>
<span class="sourceLineNo">289</span>     * @param key<a name="line.289"></a>
<span class="sourceLineNo">290</span>     *            ignored<a name="line.290"></a>
<span class="sourceLineNo">291</span>     * @param pooledObject<a name="line.291"></a>
<span class="sourceLineNo">292</span>     *            the wrapped pooled statement to be destroyed.<a name="line.292"></a>
<span class="sourceLineNo">293</span>     */<a name="line.293"></a>
<span class="sourceLineNo">294</span>    @Override<a name="line.294"></a>
<span class="sourceLineNo">295</span>    public void destroyObject(final PStmtKey key, final PooledObject&lt;DelegatingPreparedStatement&gt; pooledObject)<a name="line.295"></a>
<span class="sourceLineNo">296</span>            throws Exception {<a name="line.296"></a>
<span class="sourceLineNo">297</span>        pooledObject.getObject().getInnermostDelegate().close();<a name="line.297"></a>
<span class="sourceLineNo">298</span>    }<a name="line.298"></a>
<span class="sourceLineNo">299</span><a name="line.299"></a>
<span class="sourceLineNo">300</span>    private String getCatalogOrNull() {<a name="line.300"></a>
<span class="sourceLineNo">301</span>        String catalog = null;<a name="line.301"></a>
<span class="sourceLineNo">302</span>        try {<a name="line.302"></a>
<span class="sourceLineNo">303</span>            catalog = getCatalog();<a name="line.303"></a>
<span class="sourceLineNo">304</span>        } catch (final SQLException e) {<a name="line.304"></a>
<span class="sourceLineNo">305</span>            // Ignored<a name="line.305"></a>
<span class="sourceLineNo">306</span>        }<a name="line.306"></a>
<span class="sourceLineNo">307</span>        return catalog;<a name="line.307"></a>
<span class="sourceLineNo">308</span>    }<a name="line.308"></a>
<span class="sourceLineNo">309</span><a name="line.309"></a>
<span class="sourceLineNo">310</span>    private String getSchemaOrNull() {<a name="line.310"></a>
<span class="sourceLineNo">311</span>        String schema = null;<a name="line.311"></a>
<span class="sourceLineNo">312</span>        try {<a name="line.312"></a>
<span class="sourceLineNo">313</span>            schema = getSchema();<a name="line.313"></a>
<span class="sourceLineNo">314</span>        } catch (final SQLException e) {<a name="line.314"></a>
<span class="sourceLineNo">315</span>            // Ignored<a name="line.315"></a>
<span class="sourceLineNo">316</span>        }<a name="line.316"></a>
<span class="sourceLineNo">317</span>        return schema;<a name="line.317"></a>
<span class="sourceLineNo">318</span>    }<a name="line.318"></a>
<span class="sourceLineNo">319</span><a name="line.319"></a>
<span class="sourceLineNo">320</span>    /**<a name="line.320"></a>
<span class="sourceLineNo">321</span>     * Returns the prepared statement pool we're using.<a name="line.321"></a>
<span class="sourceLineNo">322</span>     *<a name="line.322"></a>
<span class="sourceLineNo">323</span>     * @return statement pool<a name="line.323"></a>
<span class="sourceLineNo">324</span>     * @since 2.8.0<a name="line.324"></a>
<span class="sourceLineNo">325</span>     */<a name="line.325"></a>
<span class="sourceLineNo">326</span>    public KeyedObjectPool&lt;PStmtKey, DelegatingPreparedStatement&gt; getStatementPool() {<a name="line.326"></a>
<span class="sourceLineNo">327</span>        return pstmtPool;<a name="line.327"></a>
<span class="sourceLineNo">328</span>    }<a name="line.328"></a>
<span class="sourceLineNo">329</span><a name="line.329"></a>
<span class="sourceLineNo">330</span>    /**<a name="line.330"></a>
<span class="sourceLineNo">331</span>     * {@link KeyedPooledObjectFactory} method for creating {@link PoolablePreparedStatement}s or<a name="line.331"></a>
<span class="sourceLineNo">332</span>     * {@link PoolableCallableStatement}s. The &lt;code&gt;stmtType&lt;/code&gt; field in the key determines whether a<a name="line.332"></a>
<span class="sourceLineNo">333</span>     * PoolablePreparedStatement or PoolableCallableStatement is created.<a name="line.333"></a>
<span class="sourceLineNo">334</span>     *<a name="line.334"></a>
<span class="sourceLineNo">335</span>     * @param key<a name="line.335"></a>
<span class="sourceLineNo">336</span>     *            the key for the {@link PreparedStatement} to be created<a name="line.336"></a>
<span class="sourceLineNo">337</span>     * @see #createKey(String, int, int, StatementType)<a name="line.337"></a>
<span class="sourceLineNo">338</span>     */<a name="line.338"></a>
<span class="sourceLineNo">339</span>    @SuppressWarnings("resource")<a name="line.339"></a>
<span class="sourceLineNo">340</span>    @Override<a name="line.340"></a>
<span class="sourceLineNo">341</span>    public PooledObject&lt;DelegatingPreparedStatement&gt; makeObject(final PStmtKey key) throws Exception {<a name="line.341"></a>
<span class="sourceLineNo">342</span>        if (null == key) {<a name="line.342"></a>
<span class="sourceLineNo">343</span>            throw new IllegalArgumentException("Prepared statement key is null or invalid.");<a name="line.343"></a>
<span class="sourceLineNo">344</span>        }<a name="line.344"></a>
<span class="sourceLineNo">345</span>        if (key.getStmtType() == StatementType.PREPARED_STATEMENT) {<a name="line.345"></a>
<span class="sourceLineNo">346</span>            final PreparedStatement statement = (PreparedStatement) key.createStatement(getDelegate());<a name="line.346"></a>
<span class="sourceLineNo">347</span>            @SuppressWarnings({"rawtypes", "unchecked" }) // Unable to find way to avoid this<a name="line.347"></a>
<span class="sourceLineNo">348</span>            final PoolablePreparedStatement pps = new PoolablePreparedStatement(statement, key, pstmtPool, this);<a name="line.348"></a>
<span class="sourceLineNo">349</span>            return new DefaultPooledObject&lt;&gt;(pps);<a name="line.349"></a>
<span class="sourceLineNo">350</span>        }<a name="line.350"></a>
<span class="sourceLineNo">351</span>        final CallableStatement statement = (CallableStatement) key.createStatement(getDelegate());<a name="line.351"></a>
<span class="sourceLineNo">352</span>        final PoolableCallableStatement pcs = new PoolableCallableStatement(statement, key, pstmtPool, this);<a name="line.352"></a>
<span class="sourceLineNo">353</span>        return new DefaultPooledObject&lt;&gt;(pcs);<a name="line.353"></a>
<span class="sourceLineNo">354</span>    }<a name="line.354"></a>
<span class="sourceLineNo">355</span><a name="line.355"></a>
<span class="sourceLineNo">356</span>    /**<a name="line.356"></a>
<span class="sourceLineNo">357</span>     * Normalizes the given SQL statement, producing a canonical form that is semantically equivalent to the original.<a name="line.357"></a>
<span class="sourceLineNo">358</span>     *<a name="line.358"></a>
<span class="sourceLineNo">359</span>     * @param sql The statement to be normalized.<a name="line.359"></a>
<span class="sourceLineNo">360</span>     *<a name="line.360"></a>
<span class="sourceLineNo">361</span>     * @return The canonical form of the supplied SQL statement.<a name="line.361"></a>
<span class="sourceLineNo">362</span>     */<a name="line.362"></a>
<span class="sourceLineNo">363</span>    protected String normalizeSQL(final String sql) {<a name="line.363"></a>
<span class="sourceLineNo">364</span>        return sql.trim();<a name="line.364"></a>
<span class="sourceLineNo">365</span>    }<a name="line.365"></a>
<span class="sourceLineNo">366</span><a name="line.366"></a>
<span class="sourceLineNo">367</span>    /**<a name="line.367"></a>
<span class="sourceLineNo">368</span>     * {@link KeyedPooledObjectFactory} method for passivating {@link PreparedStatement}s or {@link CallableStatement}s.<a name="line.368"></a>
<span class="sourceLineNo">369</span>     * Invokes {@link PreparedStatement#clearParameters}.<a name="line.369"></a>
<span class="sourceLineNo">370</span>     *<a name="line.370"></a>
<span class="sourceLineNo">371</span>     * @param key<a name="line.371"></a>
<span class="sourceLineNo">372</span>     *            ignored<a name="line.372"></a>
<span class="sourceLineNo">373</span>     * @param pooledObject<a name="line.373"></a>
<span class="sourceLineNo">374</span>     *            a wrapped {@link PreparedStatement}<a name="line.374"></a>
<span class="sourceLineNo">375</span>     */<a name="line.375"></a>
<span class="sourceLineNo">376</span>    @Override<a name="line.376"></a>
<span class="sourceLineNo">377</span>    public void passivateObject(final PStmtKey key, final PooledObject&lt;DelegatingPreparedStatement&gt; pooledObject)<a name="line.377"></a>
<span class="sourceLineNo">378</span>            throws Exception {<a name="line.378"></a>
<span class="sourceLineNo">379</span>        @SuppressWarnings("resource")<a name="line.379"></a>
<span class="sourceLineNo">380</span>        final DelegatingPreparedStatement dps = pooledObject.getObject();<a name="line.380"></a>
<span class="sourceLineNo">381</span>        dps.clearParameters();<a name="line.381"></a>
<span class="sourceLineNo">382</span>        dps.passivate();<a name="line.382"></a>
<span class="sourceLineNo">383</span>    }<a name="line.383"></a>
<span class="sourceLineNo">384</span><a name="line.384"></a>
<span class="sourceLineNo">385</span>    /**<a name="line.385"></a>
<span class="sourceLineNo">386</span>     * Creates or obtains a {@link CallableStatement} from the pool.<a name="line.386"></a>
<span class="sourceLineNo">387</span>     *<a name="line.387"></a>
<span class="sourceLineNo">388</span>     * @param key<a name="line.388"></a>
<span class="sourceLineNo">389</span>     *            a {@link PStmtKey} for the given arguments<a name="line.389"></a>
<span class="sourceLineNo">390</span>     * @return a {@link PoolableCallableStatement}<a name="line.390"></a>
<span class="sourceLineNo">391</span>     * @throws SQLException<a name="line.391"></a>
<span class="sourceLineNo">392</span>     *             Wraps an underlying exception.<a name="line.392"></a>
<span class="sourceLineNo">393</span>     */<a name="line.393"></a>
<span class="sourceLineNo">394</span>    private CallableStatement prepareCall(final PStmtKey key) throws SQLException {<a name="line.394"></a>
<span class="sourceLineNo">395</span>        return (CallableStatement) prepareStatement(key);<a name="line.395"></a>
<span class="sourceLineNo">396</span>    }<a name="line.396"></a>
<span class="sourceLineNo">397</span><a name="line.397"></a>
<span class="sourceLineNo">398</span>    /**<a name="line.398"></a>
<span class="sourceLineNo">399</span>     * Creates or obtains a {@link CallableStatement} from the pool.<a name="line.399"></a>
<span class="sourceLineNo">400</span>     *<a name="line.400"></a>
<span class="sourceLineNo">401</span>     * @param sql<a name="line.401"></a>
<span class="sourceLineNo">402</span>     *            the SQL string used to define the CallableStatement<a name="line.402"></a>
<span class="sourceLineNo">403</span>     * @return a {@link PoolableCallableStatement}<a name="line.403"></a>
<span class="sourceLineNo">404</span>     * @throws SQLException<a name="line.404"></a>
<span class="sourceLineNo">405</span>     *             Wraps an underlying exception.<a name="line.405"></a>
<span class="sourceLineNo">406</span>     */<a name="line.406"></a>
<span class="sourceLineNo">407</span>    @Override<a name="line.407"></a>
<span class="sourceLineNo">408</span>    public CallableStatement prepareCall(final String sql) throws SQLException {<a name="line.408"></a>
<span class="sourceLineNo">409</span>        return prepareCall(createKey(sql, StatementType.CALLABLE_STATEMENT));<a name="line.409"></a>
<span class="sourceLineNo">410</span>    }<a name="line.410"></a>
<span class="sourceLineNo">411</span><a name="line.411"></a>
<span class="sourceLineNo">412</span>    /**<a name="line.412"></a>
<span class="sourceLineNo">413</span>     * Creates or obtains a {@link CallableStatement} from the pool.<a name="line.413"></a>
<span class="sourceLineNo">414</span>     *<a name="line.414"></a>
<span class="sourceLineNo">415</span>     * @param sql<a name="line.415"></a>
<span class="sourceLineNo">416</span>     *            the SQL string used to define the CallableStatement<a name="line.416"></a>
<span class="sourceLineNo">417</span>     * @param resultSetType<a name="line.417"></a>
<span class="sourceLineNo">418</span>     *            result set type<a name="line.418"></a>
<span class="sourceLineNo">419</span>     * @param resultSetConcurrency<a name="line.419"></a>
<span class="sourceLineNo">420</span>     *            result set concurrency<a name="line.420"></a>
<span class="sourceLineNo">421</span>     * @return a {@link PoolableCallableStatement}<a name="line.421"></a>
<span class="sourceLineNo">422</span>     * @throws SQLException<a name="line.422"></a>
<span class="sourceLineNo">423</span>     *             Wraps an underlying exception.<a name="line.423"></a>
<span class="sourceLineNo">424</span>     */<a name="line.424"></a>
<span class="sourceLineNo">425</span>    @Override<a name="line.425"></a>
<span class="sourceLineNo">426</span>    public CallableStatement prepareCall(final String sql, final int resultSetType, final int resultSetConcurrency)<a name="line.426"></a>
<span class="sourceLineNo">427</span>            throws SQLException {<a name="line.427"></a>
<span class="sourceLineNo">428</span>        return prepareCall(createKey(sql, resultSetType, resultSetConcurrency, StatementType.CALLABLE_STATEMENT));<a name="line.428"></a>
<span class="sourceLineNo">429</span>    }<a name="line.429"></a>
<span class="sourceLineNo">430</span><a name="line.430"></a>
<span class="sourceLineNo">431</span>    /**<a name="line.431"></a>
<span class="sourceLineNo">432</span>     * Creates or obtains a {@link CallableStatement} from the pool.<a name="line.432"></a>
<span class="sourceLineNo">433</span>     *<a name="line.433"></a>
<span class="sourceLineNo">434</span>     * @param sql<a name="line.434"></a>
<span class="sourceLineNo">435</span>     *            the SQL string used to define the CallableStatement<a name="line.435"></a>
<span class="sourceLineNo">436</span>     * @param resultSetType<a name="line.436"></a>
<span class="sourceLineNo">437</span>     *            result set type<a name="line.437"></a>
<span class="sourceLineNo">438</span>     * @param resultSetConcurrency<a name="line.438"></a>
<span class="sourceLineNo">439</span>     *            result set concurrency<a name="line.439"></a>
<span class="sourceLineNo">440</span>     * @param resultSetHoldability<a name="line.440"></a>
<span class="sourceLineNo">441</span>     *            result set holdability<a name="line.441"></a>
<span class="sourceLineNo">442</span>     * @return a {@link PoolableCallableStatement}<a name="line.442"></a>
<span class="sourceLineNo">443</span>     * @throws SQLException<a name="line.443"></a>
<span class="sourceLineNo">444</span>     *             Wraps an underlying exception.<a name="line.444"></a>
<span class="sourceLineNo">445</span>     */<a name="line.445"></a>
<span class="sourceLineNo">446</span>    @Override<a name="line.446"></a>
<span class="sourceLineNo">447</span>    public CallableStatement prepareCall(final String sql, final int resultSetType, final int resultSetConcurrency,<a name="line.447"></a>
<span class="sourceLineNo">448</span>            final int resultSetHoldability) throws SQLException {<a name="line.448"></a>
<span class="sourceLineNo">449</span>        return prepareCall(createKey(sql, resultSetType, resultSetConcurrency,<a name="line.449"></a>
<span class="sourceLineNo">450</span>                resultSetHoldability, StatementType.CALLABLE_STATEMENT));<a name="line.450"></a>
<span class="sourceLineNo">451</span>    }<a name="line.451"></a>
<span class="sourceLineNo">452</span><a name="line.452"></a>
<span class="sourceLineNo">453</span>    /**<a name="line.453"></a>
<span class="sourceLineNo">454</span>     * Creates or obtains a {@link PreparedStatement} from the pool.<a name="line.454"></a>
<span class="sourceLineNo">455</span>     *<a name="line.455"></a>
<span class="sourceLineNo">456</span>     * @param key<a name="line.456"></a>
<span class="sourceLineNo">457</span>     *            a {@link PStmtKey} for the given arguments<a name="line.457"></a>
<span class="sourceLineNo">458</span>     * @return a {@link PoolablePreparedStatement}<a name="line.458"></a>
<span class="sourceLineNo">459</span>     * @throws SQLException<a name="line.459"></a>
<span class="sourceLineNo">460</span>     *             Wraps an underlying exception.<a name="line.460"></a>
<span class="sourceLineNo">461</span>     */<a name="line.461"></a>
<span class="sourceLineNo">462</span>    private PreparedStatement prepareStatement(final PStmtKey key) throws SQLException {<a name="line.462"></a>
<span class="sourceLineNo">463</span>        if (null == pstmtPool) {<a name="line.463"></a>
<span class="sourceLineNo">464</span>            throw new SQLException("Statement pool is null - closed or invalid PoolingConnection.");<a name="line.464"></a>
<span class="sourceLineNo">465</span>        }<a name="line.465"></a>
<span class="sourceLineNo">466</span>        try {<a name="line.466"></a>
<span class="sourceLineNo">467</span>            return pstmtPool.borrowObject(key);<a name="line.467"></a>
<span class="sourceLineNo">468</span>        } catch (final NoSuchElementException e) {<a name="line.468"></a>
<span class="sourceLineNo">469</span>            throw new SQLException("MaxOpenPreparedStatements limit reached", e);<a name="line.469"></a>
<span class="sourceLineNo">470</span>        } catch (final RuntimeException e) {<a name="line.470"></a>
<span class="sourceLineNo">471</span>            throw e;<a name="line.471"></a>
<span class="sourceLineNo">472</span>        } catch (final Exception e) {<a name="line.472"></a>
<span class="sourceLineNo">473</span>            throw new SQLException("Borrow prepareStatement from pool failed", e);<a name="line.473"></a>
<span class="sourceLineNo">474</span>        }<a name="line.474"></a>
<span class="sourceLineNo">475</span>    }<a name="line.475"></a>
<span class="sourceLineNo">476</span><a name="line.476"></a>
<span class="sourceLineNo">477</span>    /**<a name="line.477"></a>
<span class="sourceLineNo">478</span>     * Creates or obtains a {@link PreparedStatement} from the pool.<a name="line.478"></a>
<span class="sourceLineNo">479</span>     *<a name="line.479"></a>
<span class="sourceLineNo">480</span>     * @param sql<a name="line.480"></a>
<span class="sourceLineNo">481</span>     *            the SQL string used to define the PreparedStatement<a name="line.481"></a>
<span class="sourceLineNo">482</span>     * @return a {@link PoolablePreparedStatement}<a name="line.482"></a>
<span class="sourceLineNo">483</span>     * @throws SQLException<a name="line.483"></a>
<span class="sourceLineNo">484</span>     *             Wraps an underlying exception.<a name="line.484"></a>
<span class="sourceLineNo">485</span>     */<a name="line.485"></a>
<span class="sourceLineNo">486</span>    @Override<a name="line.486"></a>
<span class="sourceLineNo">487</span>    public PreparedStatement prepareStatement(final String sql) throws SQLException {<a name="line.487"></a>
<span class="sourceLineNo">488</span>        return prepareStatement(createKey(sql));<a name="line.488"></a>
<span class="sourceLineNo">489</span>    }<a name="line.489"></a>
<span class="sourceLineNo">490</span><a name="line.490"></a>
<span class="sourceLineNo">491</span>    /*<a name="line.491"></a>
<span class="sourceLineNo">492</span>     * Creates or obtains a {@link PreparedStatement} from the pool.<a name="line.492"></a>
<span class="sourceLineNo">493</span>     *<a name="line.493"></a>
<span class="sourceLineNo">494</span>     * @param sql<a name="line.494"></a>
<span class="sourceLineNo">495</span>     *            the SQL string used to define the PreparedStatement<a name="line.495"></a>
<span class="sourceLineNo">496</span>     * @param autoGeneratedKeys<a name="line.496"></a>
<span class="sourceLineNo">497</span>     *            A flag indicating whether auto-generated keys should be returned; one of<a name="line.497"></a>
<span class="sourceLineNo">498</span>     *            &lt;code&gt;Statement.RETURN_GENERATED_KEYS&lt;/code&gt; or &lt;code&gt;Statement.NO_GENERATED_KEYS&lt;/code&gt;.<a name="line.498"></a>
<span class="sourceLineNo">499</span>     * @return a {@link PoolablePreparedStatement}<a name="line.499"></a>
<span class="sourceLineNo">500</span>     * @throws SQLException<a name="line.500"></a>
<span class="sourceLineNo">501</span>     *             Wraps an underlying exception.<a name="line.501"></a>
<span class="sourceLineNo">502</span>     */<a name="line.502"></a>
<span class="sourceLineNo">503</span>    @Override<a name="line.503"></a>
<span class="sourceLineNo">504</span>    public PreparedStatement prepareStatement(final String sql, final int autoGeneratedKeys) throws SQLException {<a name="line.504"></a>
<span class="sourceLineNo">505</span>        return prepareStatement(createKey(sql, autoGeneratedKeys));<a name="line.505"></a>
<span class="sourceLineNo">506</span>    }<a name="line.506"></a>
<span class="sourceLineNo">507</span><a name="line.507"></a>
<span class="sourceLineNo">508</span>    /**<a name="line.508"></a>
<span class="sourceLineNo">509</span>     * Creates or obtains a {@link PreparedStatement} from the pool.<a name="line.509"></a>
<span class="sourceLineNo">510</span>     *<a name="line.510"></a>
<span class="sourceLineNo">511</span>     * @param sql<a name="line.511"></a>
<span class="sourceLineNo">512</span>     *            the SQL string used to define the PreparedStatement<a name="line.512"></a>
<span class="sourceLineNo">513</span>     * @param columnIndexes<a name="line.513"></a>
<span class="sourceLineNo">514</span>     *            An array of column indexes indicating the columns that should be returned from the inserted row or<a name="line.514"></a>
<span class="sourceLineNo">515</span>     *            rows.<a name="line.515"></a>
<span class="sourceLineNo">516</span>     * @return a {@link PoolablePreparedStatement}<a name="line.516"></a>
<span class="sourceLineNo">517</span>     * @throws SQLException<a name="line.517"></a>
<span class="sourceLineNo">518</span>     *             Wraps an underlying exception.<a name="line.518"></a>
<span class="sourceLineNo">519</span>     *<a name="line.519"></a>
<span class="sourceLineNo">520</span>     */<a name="line.520"></a>
<span class="sourceLineNo">521</span>    @Override<a name="line.521"></a>
<span class="sourceLineNo">522</span>    public PreparedStatement prepareStatement(final String sql, final int columnIndexes[]) throws SQLException {<a name="line.522"></a>
<span class="sourceLineNo">523</span>        return prepareStatement(createKey(sql, columnIndexes));<a name="line.523"></a>
<span class="sourceLineNo">524</span>    }<a name="line.524"></a>
<span class="sourceLineNo">525</span><a name="line.525"></a>
<span class="sourceLineNo">526</span>    /**<a name="line.526"></a>
<span class="sourceLineNo">527</span>     * Creates or obtains a {@link PreparedStatement} from the pool.<a name="line.527"></a>
<span class="sourceLineNo">528</span>     *<a name="line.528"></a>
<span class="sourceLineNo">529</span>     * @param sql<a name="line.529"></a>
<span class="sourceLineNo">530</span>     *            the SQL string used to define the PreparedStatement<a name="line.530"></a>
<span class="sourceLineNo">531</span>     * @param resultSetType<a name="line.531"></a>
<span class="sourceLineNo">532</span>     *            result set type<a name="line.532"></a>
<span class="sourceLineNo">533</span>     * @param resultSetConcurrency<a name="line.533"></a>
<span class="sourceLineNo">534</span>     *            result set concurrency<a name="line.534"></a>
<span class="sourceLineNo">535</span>     * @return a {@link PoolablePreparedStatement}<a name="line.535"></a>
<span class="sourceLineNo">536</span>     * @throws SQLException<a name="line.536"></a>
<span class="sourceLineNo">537</span>     *             Wraps an underlying exception.<a name="line.537"></a>
<span class="sourceLineNo">538</span>     */<a name="line.538"></a>
<span class="sourceLineNo">539</span>    @Override<a name="line.539"></a>
<span class="sourceLineNo">540</span>    public PreparedStatement prepareStatement(final String sql, final int resultSetType, final int resultSetConcurrency)<a name="line.540"></a>
<span class="sourceLineNo">541</span>            throws SQLException {<a name="line.541"></a>
<span class="sourceLineNo">542</span>        return prepareStatement(createKey(sql, resultSetType, resultSetConcurrency));<a name="line.542"></a>
<span class="sourceLineNo">543</span>    }<a name="line.543"></a>
<span class="sourceLineNo">544</span><a name="line.544"></a>
<span class="sourceLineNo">545</span>    /**<a name="line.545"></a>
<span class="sourceLineNo">546</span>     * Creates or obtains a {@link PreparedStatement} from the pool.<a name="line.546"></a>
<span class="sourceLineNo">547</span>     *<a name="line.547"></a>
<span class="sourceLineNo">548</span>     * @param sql<a name="line.548"></a>
<span class="sourceLineNo">549</span>     *            the SQL string used to define the PreparedStatement<a name="line.549"></a>
<span class="sourceLineNo">550</span>     * @param resultSetType<a name="line.550"></a>
<span class="sourceLineNo">551</span>     *            result set type<a name="line.551"></a>
<span class="sourceLineNo">552</span>     * @param resultSetConcurrency<a name="line.552"></a>
<span class="sourceLineNo">553</span>     *            result set concurrency<a name="line.553"></a>
<span class="sourceLineNo">554</span>     * @param resultSetHoldability<a name="line.554"></a>
<span class="sourceLineNo">555</span>     *            result set holdability<a name="line.555"></a>
<span class="sourceLineNo">556</span>     * @return a {@link PoolablePreparedStatement}<a name="line.556"></a>
<span class="sourceLineNo">557</span>     * @throws SQLException<a name="line.557"></a>
<span class="sourceLineNo">558</span>     *             Wraps an underlying exception.<a name="line.558"></a>
<span class="sourceLineNo">559</span>     */<a name="line.559"></a>
<span class="sourceLineNo">560</span>    @Override<a name="line.560"></a>
<span class="sourceLineNo">561</span>    public PreparedStatement prepareStatement(final String sql, final int resultSetType, final int resultSetConcurrency,<a name="line.561"></a>
<span class="sourceLineNo">562</span>            final int resultSetHoldability) throws SQLException {<a name="line.562"></a>
<span class="sourceLineNo">563</span>        return prepareStatement(createKey(sql, resultSetType, resultSetConcurrency, resultSetHoldability));<a name="line.563"></a>
<span class="sourceLineNo">564</span>    }<a name="line.564"></a>
<span class="sourceLineNo">565</span><a name="line.565"></a>
<span class="sourceLineNo">566</span>    /**<a name="line.566"></a>
<span class="sourceLineNo">567</span>     * Creates or obtains a {@link PreparedStatement} from the pool.<a name="line.567"></a>
<span class="sourceLineNo">568</span>     *<a name="line.568"></a>
<span class="sourceLineNo">569</span>     * @param sql<a name="line.569"></a>
<span class="sourceLineNo">570</span>     *            the SQL string used to define the PreparedStatement<a name="line.570"></a>
<span class="sourceLineNo">571</span>     * @param columnNames<a name="line.571"></a>
<span class="sourceLineNo">572</span>     *            column names<a name="line.572"></a>
<span class="sourceLineNo">573</span>     * @return a {@link PoolablePreparedStatement}<a name="line.573"></a>
<span class="sourceLineNo">574</span>     * @throws SQLException<a name="line.574"></a>
<span class="sourceLineNo">575</span>     *             Wraps an underlying exception.<a name="line.575"></a>
<span class="sourceLineNo">576</span>     */<a name="line.576"></a>
<span class="sourceLineNo">577</span>    @Override<a name="line.577"></a>
<span class="sourceLineNo">578</span>    public PreparedStatement prepareStatement(final String sql, final String columnNames[]) throws SQLException {<a name="line.578"></a>
<span class="sourceLineNo">579</span>        return prepareStatement(createKey(sql, columnNames));<a name="line.579"></a>
<span class="sourceLineNo">580</span>    }<a name="line.580"></a>
<span class="sourceLineNo">581</span><a name="line.581"></a>
<span class="sourceLineNo">582</span>    /**<a name="line.582"></a>
<span class="sourceLineNo">583</span>     * Sets whether the pool of statements should be cleared when the connection is returned to its pool.<a name="line.583"></a>
<span class="sourceLineNo">584</span>     * Default is false.<a name="line.584"></a>
<span class="sourceLineNo">585</span>     *<a name="line.585"></a>
<span class="sourceLineNo">586</span>     * @param clearStatementPoolOnReturn clear or not<a name="line.586"></a>
<span class="sourceLineNo">587</span>     * @since 2.8.0<a name="line.587"></a>
<span class="sourceLineNo">588</span>     */<a name="line.588"></a>
<span class="sourceLineNo">589</span>    public void setClearStatementPoolOnReturn(final boolean clearStatementPoolOnReturn) {<a name="line.589"></a>
<span class="sourceLineNo">590</span>        this.clearStatementPoolOnReturn = clearStatementPoolOnReturn;<a name="line.590"></a>
<span class="sourceLineNo">591</span>    }<a name="line.591"></a>
<span class="sourceLineNo">592</span><a name="line.592"></a>
<span class="sourceLineNo">593</span>    /**<a name="line.593"></a>
<span class="sourceLineNo">594</span>     * Sets the prepared statement pool.<a name="line.594"></a>
<span class="sourceLineNo">595</span>     *<a name="line.595"></a>
<span class="sourceLineNo">596</span>     * @param pool<a name="line.596"></a>
<span class="sourceLineNo">597</span>     *            the prepared statement pool.<a name="line.597"></a>
<span class="sourceLineNo">598</span>     */<a name="line.598"></a>
<span class="sourceLineNo">599</span>    public void setStatementPool(final KeyedObjectPool&lt;PStmtKey, DelegatingPreparedStatement&gt; pool) {<a name="line.599"></a>
<span class="sourceLineNo">600</span>        pstmtPool = pool;<a name="line.600"></a>
<span class="sourceLineNo">601</span>    }<a name="line.601"></a>
<span class="sourceLineNo">602</span><a name="line.602"></a>
<span class="sourceLineNo">603</span>    @Override<a name="line.603"></a>
<span class="sourceLineNo">604</span>    public synchronized String toString() {<a name="line.604"></a>
<span class="sourceLineNo">605</span>        if (pstmtPool != null) {<a name="line.605"></a>
<span class="sourceLineNo">606</span>            return "PoolingConnection: " + pstmtPool.toString();<a name="line.606"></a>
<span class="sourceLineNo">607</span>        }<a name="line.607"></a>
<span class="sourceLineNo">608</span>        return "PoolingConnection: null";<a name="line.608"></a>
<span class="sourceLineNo">609</span>    }<a name="line.609"></a>
<span class="sourceLineNo">610</span><a name="line.610"></a>
<span class="sourceLineNo">611</span>    /**<a name="line.611"></a>
<span class="sourceLineNo">612</span>     * {@link KeyedPooledObjectFactory} method for validating pooled statements. Currently always returns true.<a name="line.612"></a>
<span class="sourceLineNo">613</span>     *<a name="line.613"></a>
<span class="sourceLineNo">614</span>     * @param key<a name="line.614"></a>
<span class="sourceLineNo">615</span>     *            ignored<a name="line.615"></a>
<span class="sourceLineNo">616</span>     * @param pooledObject<a name="line.616"></a>
<span class="sourceLineNo">617</span>     *            ignored<a name="line.617"></a>
<span class="sourceLineNo">618</span>     * @return {@code true}<a name="line.618"></a>
<span class="sourceLineNo">619</span>     */<a name="line.619"></a>
<span class="sourceLineNo">620</span>    @Override<a name="line.620"></a>
<span class="sourceLineNo">621</span>    public boolean validateObject(final PStmtKey key, final PooledObject&lt;DelegatingPreparedStatement&gt; pooledObject) {<a name="line.621"></a>
<span class="sourceLineNo">622</span>        return true;<a name="line.622"></a>
<span class="sourceLineNo">623</span>    }<a name="line.623"></a>
<span class="sourceLineNo">624</span>}<a name="line.624"></a>




























































</pre>
</div>
</body>
</html>
